// Copyright 2000 by David Rhodes and Robert Dick.
// All rights reserved.

#ifndef ARG_PACK_H_
#define ARG_PACK_H_

/*###########################################################################*/
class ostream;
#include "RAlgo.h"
#include "RString.h"
#include "version.h"

/*###########################################################################*/
class ArgPack {
public:
// Holds all arguments to tgff. 

	static void init(int argc, char *const argv[]);
	static void help(ostream &os);

		static RString	tg_label_;
		static int		tg_cnt_;
		static double	vertex_time_;

		static double	vertex_cnt_av_;
		static double	vertex_cnt_mul_;

		static int		vertex_in_deg_;
		static int		vertex_out_deg_;

		static bool		task_unique_;
		static int		task_type_cnt_;

		static bool		trans_unique_;
		static int		trans_type_cnt_;

		static RVector<RString> task_attrib_name_;
		static RVector<double> task_attrib_av_;
		static RVector<double> task_attrib_mul_;
		static RVector<double> task_attrib_round_;

		static double	p_laxity_;
		static bool		p_greater_deadline_;
		static double	prob_hard_deadline_;
		static double	soft_deadline_mul_;

		static bool		urv_merge_;
		static RString	table_label_;
		static int		table_cnt_;

		static double	table_type_ratio_;

		static RVector<int>		period_mul_;

		static double entries_per_type_av_;
		static double entries_per_type_mul_;

		static RVector<RString>	table_name_;
		static RVector<double>	table_av_;
		static RVector<double>	table_mul_;
		static RVector<double>	table_jitter_;
		static RVector<double>	table_round_;

		static RVector<RString>	type_name_;
		static RVector<double>	type_av_;
		static RVector<double>	type_mul_;
		static RVector<double>	type_jitter_;
		static RVector<double>	type_round_;

		static int seed_;
		static int misc_type_cnt_;

		static RString data_file_name_;
		static RString eps_file_name_;
		static RString opt_file_name_;
};


/*###########################################################################*/
#endif






