// Copyright 2000 by David Rhodes and Robert Dick.
// All rights reserved.

#ifndef D_BASE_H_
#define D_BASE_H_

/*###########################################################################*/
class ostream;
#include <cstddef>
#include "RString.h"
#include "RVector.h"

/*###########################################################################*/
class DBase {
public:
	DBase(int table_offset, int type_cnt);
	void print_to(ostream &os) const;
	void trans_print_to(ostream &os) const;
	friend ostream &operator<<(ostream &os, /**/ const DBase &db)
	  {db.print_to(os); return os;}

	static double flat_merge(double alpha, double a, double b);
private:

		int type_cnt_;
		int table_offset_;

// PE, attribute
		RVector2<double> table_;

// PE, type, attribute, different implementations
		RVector3<RVector<double> > table_type_;

		const RVector<RString> &table_name_;
		const RVector<RString> &type_name_;

		size_t f_width_;
};

/*###########################################################################*/
#endif
